
#include <iostream>
#include <cstdlib>
#include <cstring>
using namespace std;

int n;
int v[13];
bool con[13][13];

long long tbl[1<<13][13][13];
long long way[1<<13][13][13];
int main(void){
  int cases;
  cin >> cases;
  while(cases--){
    int m;
    cin >> n >> m;
    for(int i=0;i<n;i++)
      cin >> v[i];
    memset(con,0,sizeof(con));
    memset(way,0,sizeof(way));
    memset(tbl,0,sizeof(tbl));
    for(int i=0;i<m;i++){
      int a,b;
      cin >> a >> b;
      con[a-1][b-1] = con[b-1][a-1] = true;
    }
    if(n==1){
      cout << v[0] << " " << 1 << endl;
      continue;
    }
    for(int i=0;i<n;i++)
      for(int j=0;j<n;j++){
        if(i==j) continue;
        if(!con[i][j]) continue;
        tbl[(1<<i)|(1<<j)][i][j] = v[i]+v[j] +v[i]*v[j];
        way[(1<<i)|(1<<j)][i][j] = 1LL;
        tbl[(1<<i)|(1<<j)][j][i] = v[i]+v[j] +v[i]*v[j];
        way[(1<<i)|(1<<j)][j][i] = 1LL;
      }
    for(int mask=0;mask<(1<<n);mask++){
      for(int i=0;i<n;i++){
        if(!(mask&(1<<i))) continue;
        for(int j=0;j<n;j++){
          if(way[mask][i][j] == 0) continue;
          for(int k=0;k<n;k++){
            if((mask&(1<<k)) || !con[j][k]) continue;
            long long nv = tbl[mask][i][j];
            int nmask = mask | (1<<k);
            nv += v[j]*v[k] + v[k];
            if(con[i][k]) nv += v[i]*v[j]*v[k];
            if(tbl[nmask][j][k] < nv){
              tbl[nmask][j][k] = nv;
              way[nmask][j][k] = way[mask][i][j];
            }else if(tbl[nmask][j][k] == nv){
              way[nmask][j][k] += way[mask][i][j];
            }
          }
        }
      }
    }
    long long ans = 0;
    long long count = 0;
    for(int i=0;i<n;i++)
      for(int j=0;j<n;j++){
        if(ans < tbl[(1<<n)-1][i][j]){
          ans   = tbl[(1<<n)-1][i][j];
          count = way[(1<<n)-1][i][j];
        }else if(ans == tbl[(1<<n)-1][i][j]){
          count += way[(1<<n)-1][i][j];
        }
      }
    cout << ans << " " << count/2 << endl;
  }
  return 0;
}
